Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/scripts/terrainCulling.cfg
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/scripts/terrainCulling.cfg	(revision 1266)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/scripts/terrainCulling.cfg	(revision 1270)
@@ -1,2 +1,11 @@
+#
+#  Online culling settings
+#
+
+#OnlineCullingAlgorithm=CHC
+OnlineCullingAlgorithm=SWC
+#OnlineCullingAlgorithm=VFC
+
+
 ######################################################################
 
@@ -11,18 +20,17 @@
 
 #Scene=../../../../../resources/media/house_test1.iv
-#Scene=../../../../../resources/media/city1500_flat_1.iv;../../../../../resources/media/roofs_1500.iv;../../../../../resources/media/CityRoads60.iv
+Scene=../../../../../resources/media/city1500_flat_1.iv;../../../../../resources/media/roofs_1500.iv;../../../../../resources/media/CityRoads60.iv
 #Scene=../../../../../resources/media/city1.iv;../../../../../resources/media/roofs_1500.iv;../../../../../resources/media/CityRoads60.iv
 
 # current view point
-#ViewX=830
-#ViewY=300
-#ViewZ=-540
+ViewX=830
+ViewY=300
+ViewZ=-540
 
 #
-# The visibility environment: load the view cells from there
+# The view cells
 #
 
-#VisibilityEnvironment=D:/svn/gametools/GTP/trunk/Lib/Vis/Preprocessing/scripts/generate_viewcells.env
-#VisibilityEnvironment=../../../../../../../GTP/trunk/Lib/Vis/Preprocessing/scripts/generate_viewcells.env
+ViewCells=../../../../../../../GTP/trunk/Lib/Vis/Preprocessing/scripts/vienna-visibility.xml.zip
 
 
@@ -40,5 +48,5 @@
 #
 
-ViewX=707
-ViewY=5000
-ViewZ=528
+#ViewX=707
+#ViewY=5000
+#ViewZ=528
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlRenderer.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlRenderer.vcproj	(revision 1264)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlRenderer.vcproj	(revision 1270)
@@ -75,5 +75,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				AdditionalIncludeDirectories="..\src;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\..\..\..\..\..\NonGTP\Zlib\include;&quot;$(CG_INC_PATH)&quot;"
+				AdditionalIncludeDirectories="..\..\src;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\..\..\..\..\..\..\NonGTP\Zlib\include;&quot;$(CG_INC_PATH)&quot;"
 				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;QTGLRENDERER_EXPORTS"
 				RuntimeLibrary="2"
@@ -93,5 +93,5 @@
 				OutputFile="$(OutDir)/QtGlRenderer.dll"
 				LinkIncremental="1"
-				AdditionalLibraryDirectories="&quot;$(QTDIR)\lib&quot;;..\..\..\..\..\..\NonGTP\Zlib\lib;&quot;$(CG_LIB_PATH)&quot;;&quot;..\lib\$(ConfigurationName)&quot;;..\src\GL;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib"
+				AdditionalLibraryDirectories="&quot;$(QTDIR)\lib&quot;;..\..\..\..\..\..\..\NonGTP\Zlib\lib;&quot;$(CG_LIB_PATH)&quot;;..\..\src\GL;..\..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;&quot;..\..\lib\$(ConfigurationName)&quot;"
 				GenerateDebugInformation="FALSE"
 				SubSystem="2"
Index: GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlRendererDll.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlRendererDll.cpp	(revision 1270)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/QtGlRenderer/QtGlRendererDll.cpp	(revision 1270)
@@ -0,0 +1,43 @@
+#include "QtGlRenderer.h"
+#include "Preprocessor.h"
+
+namespace GtpVisibilityPreprocessor {
+
+QApplication *app = NULL; 
+//QtGlRendererWidget *rendererWidget = NULL;
+//QtGlDebuggerWidget *debuggerWidget = NULL;
+
+//-----------------------------------------------------------------------
+extern "C"  __declspec(dllexport) GlRendererWidget *LoadRenderWidget(Preprocessor *p)
+{
+	int argc = 0;
+	// create a qt application first (must be created before any opengl widget ...)
+	app = new QApplication(argc, NULL);
+
+	if (!QGLFormat::hasOpenGL() || !QGLPixelBuffer::hasOpenGLPbuffers()) {
+		QMessageBox::information(0, "OpenGL pbuffers", 
+			"This system does not support OpenGL/pbuffers.",
+			QMessageBox::Ok);
+		return NULL;
+	}
+	
+	// note matt: capsulate qt dependent code as good as possible
+	QtGlRendererWidget *rendererWidget = 
+		new QtGlRendererWidget(p->mSceneGraph, p->mViewCellsManager, p->mKdTree);
+
+	rendererWidget->resize(640, 480);
+	rendererWidget->Show();
+	app->exec();
+
+	return rendererWidget;
+}
+
+//-----------------------------------------------------------------------
+extern "C" void __declspec(dllexport) dllStopPlugin()
+{
+	delete app;
+}
+
+
+
+} 