Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/include/OgreOcclusionCullingSceneManager.h
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/include/OgreOcclusionCullingSceneManager.h	(revision 1251)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/include/OgreOcclusionCullingSceneManager.h	(revision 1276)
@@ -207,4 +207,7 @@
 
 	bool mDeleteQueueAfterRendering;
+
+	// normal terrain rendering
+	bool mNormalExecution;
 };
 
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/Plugin_VisibilitySceneManager.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/Plugin_VisibilitySceneManager.vcproj	(revision 1273)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/Plugin_VisibilitySceneManager.vcproj	(revision 1276)
@@ -87,5 +87,6 @@
 				OmitFramePointers="TRUE"
 				EnableFiberSafeOptimizations="TRUE"
-				OptimizeForProcessor="2"
+				OptimizeForProcessor="3"
+				OptimizeForWindowsApplication="TRUE"
 				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include&quot;;..\include;..\..\..\OnlineCullingCHC\include;..\..\..\Preprocessing\src"
 				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;PLUGIN_KD_TERRAIN_EXPORTS;GTP_VISIBILITY_MODIFIED_OGRE"
@@ -111,5 +112,5 @@
 				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;$(OGRE_PATH)\Dependencies\lib\$(ConfigurationName)&quot;;&quot;..\..\..\Preprocessing\lib\$(ConfigurationName)&quot;;..\..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\Preprocessing\src\GL;..\..\..\..\..\..\..\NonGTP\Zlib\lib;&quot;..\..\lib\$(ConfigurationName)&quot;"
 				ModuleDefinitionFile="..\misc\OgreVisibilitySceneManager.def"
-				GenerateDebugInformation="TRUE"
+				GenerateDebugInformation="FALSE"
 				SubSystem="2"
 				OptimizeReferences="2"
Index: GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOcclusionCullingSceneManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOcclusionCullingSceneManager.cpp	(revision 1267)
+++ GTP/trunk/Lib/Vis/OnlineCullingCHC/OGRE/src/OgreOcclusionCullingSceneManager.cpp	(revision 1276)
@@ -21,6 +21,4 @@
 #include "OgreBoundingBoxConverter.h"
 
-// normal terrain rendering
-const static NORMAL_RENDER_HACK = false;
 
 namespace Ogre {
@@ -52,5 +50,6 @@
 mCurrentViewCell(NULL),
 mElementaryViewCell(NULL),
-mDeleteQueueAfterRendering(true)
+mDeleteQueueAfterRendering(true),
+mNormalExecution(false)
 {
 	Ogre::LogManager::getSingleton().logMessage("creating occlusion culling scene manager");
@@ -210,5 +209,5 @@
 const Pass *OcclusionCullingSceneManager::_setPass(const Pass* pass, bool evenIfSuppressed)
 {
-	if (NORMAL_RENDER_HACK)
+	if (mNormalExecution)
 	{
 		return SceneManager::_setPass(pass);
@@ -287,5 +286,5 @@
 														bool onlyShadowCasters)
 {
-	if (NORMAL_RENDER_HACK)
+	if (mNormalExecution)
 	{
 		OctreeSceneManager::_findVisibleObjects(cam, onlyShadowCasters);
@@ -328,5 +327,5 @@
 void OcclusionCullingSceneManager::_renderVisibleObjects()
 {
-	if (NORMAL_RENDER_HACK)
+	if (mNormalExecution)
 	{
 		OctreeSceneManager::_renderVisibleObjects();
@@ -462,5 +461,5 @@
 void OcclusionCullingSceneManager::_updateSceneGraph(Camera* cam)
 {
-	if (NORMAL_RENDER_HACK)
+	if (mNormalExecution)
 	{
 		OctreeSceneManager::_updateSceneGraph(cam);
@@ -574,4 +573,9 @@
 		}
 
+		return true;
+	}
+	if (key == "NormalExecution")
+	{ 
+		mNormalExecution = *static_cast<const bool *>(val);
 		return true;
 	}
@@ -675,5 +679,5 @@
 
         // Do transparents (always descending)
-		if (NORMAL_RENDER_HACK || !mSkipTransparents)
+		if (mNormalExecution || !mSkipTransparents)
 		{
 			renderObjects(pPriorityGrp->getTransparents(), 
@@ -688,5 +692,5 @@
 bool OcclusionCullingSceneManager::validatePassForRendering(Pass* pass)
 {
-	if (NORMAL_RENDER_HACK)
+	if (mNormalExecution)
 	{
 		return SceneManager::validatePassForRendering(pass);
@@ -710,5 +714,5 @@
 															QueuedRenderableCollection::OrganisationMode om)
 {
-	if (NORMAL_RENDER_HACK || !mIsItemBufferPhase)
+	if (mNormalExecution || !mIsItemBufferPhase)
 	{
 		TerrainSceneManager::_renderQueueGroupObjects(pGroup, om);